Imports System.Configuration
Imports System.Data
Imports System.Data.OleDb

Public Class WebForm1
    Inherits System.Web.UI.Page
    Protected connectString As String
    Protected WithEvents TextBox1 As System.Web.UI.WebControls.TextBox
    Protected WithEvents TextBox2 As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label2 As System.Web.UI.WebControls.Label
    Protected WithEvents Label3 As System.Web.UI.WebControls.Label
    Protected WithEvents Button1 As System.Web.UI.WebControls.Button
    Protected WithEvents Button2 As System.Web.UI.WebControls.Button
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' There are 2 completed connection strings (SQL and Access) in the web.config file, and one that 
        ' isn() 't complete, which has 2 parts accessDB and accessConnection. The reason for this third
        ' one is to show that you can dynamically set the directory to wherever your webapp is running.
        connectString = ConfigurationSettings.AppSettings("accessConnection") _
            & Server.MapPath(ConfigurationSettings.AppSettings("accessDB"))
        ' If we wanted to do this with SQL Server, we would use SqlConnection, SqlCommand, SqlDataReader...
        ' all in the System.Data.SqlClient namespace.

        ShowDataViaOleDataReader()
        ShowDataViaOleDataAdapter()
        ' EnableViewstate is OFF for the label on the screen.

        ' When you use MS Access, because it is not intended as web solution database but rather as a local
        ' desktop database, you need to change the security permissions on it in order to be able to delete
        ' and insert items into it. On your database file, in my case db1.mdb, you will need to open up 
        ' Windows Explorer, go to the properties for the db1.mdb file, click on the Security tab, and Add
        ' Everyone. Make sure that everything is checked just like in SecurityForDB.gif (which I've provided).
        ' Use "View in Browser" from the Solution Explorer on the gif
    End Sub

    Private Sub ShowDataViaOleDataReader()
        Dim connectionString As String
        Dim sqlStatement As String

        Dim connectToAccess As OleDbConnection
        Dim commandForAccess As OleDbCommand
        Dim accessDataReader As OleDbDataReader

        ' Create a connection
        ' connectionString = ConfigurationSettings.AppSettings("connectAccess")  ' Not using this one for now
        connectionString = connectString
        connectToAccess = New OleDbConnection(connectionString)
        ' What's the SQL we will use?
        sqlStatement = "select * from table1"

        ' Create the command
        commandForAccess = New OleDbCommand()
        commandForAccess.Connection = connectToAccess ' could have added connectToAccess in constructor above
        commandForAccess.CommandText = sqlStatement

        ' Open the connection to the database
        commandForAccess.Connection.Open()
        ' Issue the command and get the reader
        accessDataReader = commandForAccess.ExecuteReader()

        Label1.Text += "<br>Show Data from a Ole Data Reader<br>"
        Do While accessDataReader.Read() = True
            Label1.Text += "<hr><hr>"
            Label1.Text += "ID = " & accessDataReader("Product_ID") & "<br>"
            Label1.Text += "Name = " & accessDataReader("Product_Name") & "<br>"
            Label1.Text += "Price = " & accessDataReader("Product_Price") & "<br>"
        Loop

        ' Close the connection
        commandForAccess.Connection.Close()

    End Sub

    Private Sub ShowDataViaOleDataAdapter()
        Dim connectionString As String
        Dim sqlStatement As String

        Dim connectToAccess As OleDbConnection
        Dim myData As DataSet
        Dim accessDataAdapter As OleDbDataAdapter

        ' Create a connection
        'connectionString = ConfigurationSettings.AppSettings("connectAccess")
        connectionString = connectString
        connectToAccess = New OleDbConnection(connectionString)
        ' What's the SQL we will use?
        sqlStatement = "select * from table1"

        ' Create the dataset
        myData = New DataSet()

        ' Create the Data Adapter
        accessDataAdapter = New OleDbDataAdapter()
        accessDataAdapter.SelectCommand = New OleDbCommand(sqlStatement)
        accessDataAdapter.SelectCommand.Connection = New OleDbConnection(connectionString)

        ' The Data Adapter automatically opens the database connection, runs the query, stores the data
        ' in the dataset, and then closes it for us.
        accessDataAdapter.Fill(myData, "Table1")

        Dim row As DataRow

        ' We are now dealing with a disconnected dataset, i.e. we aren't reading from the database, we're
        ' reading from memory.
        Label1.Text += "<br><br>Show Data from a Ole DataAdapter<br>"
        For Each row In myData.Tables(0).Rows
            Label1.Text += "<hr><hr>"
            Label1.Text += "ID = " & row("Product_ID") & "<br>"
            Label1.Text += "Name = " & row("Product_Name") & "<br>"
            Label1.Text += "Price = " & row("Product_Price") & "<br>"
            row("Product_Price") = 5.45
        Next

        ' Close the connection? Well,the connection is already closed!
    End Sub

    Private Sub InsertData(ByVal name As String, ByVal price As Decimal)
        ' In this subroutine, I use some short-hand
        Dim connection As New OleDbConnection(connectString)
        Dim insertStatement As New OleDbCommand("insert into table1 (product_name, product_price) values (@Name, @Price)")

        ' Tell the insertStatement which connection to use
        insertStatement.Connection = connection

        ' when you need to pass values that are in variables to in a SQL Statement, it is a bad idea to just use
        ' += or & to build up the entire string, from both a security perspective and you will need to escape
        ' characters yourself. Use the SQL parameters for passing in your values. These are defined in your sql
        ' statement with @name
        insertStatement.Parameters.Add(New OleDbParameter("@Name", OleDbType.VarChar, 20)) 'this says 20 characters
        insertStatement.Parameters.Add(New OleDbParameter("@Price", OleDbType.Currency))

        insertStatement.Parameters("@Name").Value = name
        insertStatement.Parameters("@Price").Value = price

        connection.Open()
        ' Let's run the insert statement
        Select Case (insertStatement.ExecuteNonQuery())
            Case 0
                ' it didn't work because it's telling me that 0 rows were affected by my statement. 
                ' But it didn't throw an exception. Something odd happened.
            Case 1
                ' it worked properly because I inserted 1 row, and 1 row was affected
            Case Else
                ' More than 1 row was affected. This is impossible with an insert statement, but here to point
                ' out that it is impossible.
        End Select
        connection.Close()

    End Sub

    Private Sub DeleteData()
        ' In this subroutine, I use some short-hand
        Dim connection As New OleDbConnection(connectString)
        Dim deleteStatement As New OleDbCommand("delete from table1") ' this clears everything in the table

        ' Tell the insertStatement which connection to use
        deleteStatement.Connection = connection

        connection.Open()
        Select Case (deleteStatement.ExecuteNonQuery())
            Case 0
                ' The table was already empty.
            Case 1
                ' Only 1 in the table
            Case Else
                ' More than 1 item was in the table and was successfully deleted
        End Select
        connection.Close()

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        InsertData(TextBox1.Text, TextBox2.Text)
        ' The user will not see this updated information because the Button_Click occurred after Page_Load,
        ' and the getting and showing data from the DB is in the Page_load
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        DeleteData()
        ' The user will not see this updated information because the Button_Click occurred after Page_Load,
        ' and the getting and showing data from the DB is in the Page_load
    End Sub
End Class
