' This web form throws an example when the button is clicked. It catches the exception
' in order to wrap it in an exception that has more properties, and then throws that one.
' The Page_Error handler is used to catch the exception and deal with it, showing
' how to manage avoiding the user seeing exception information.
Public Class WebForm1
    Inherits System.Web.UI.Page
    Protected WithEvents Button2 As System.Web.UI.WebControls.Button
    Protected WithEvents Button1 As System.Web.UI.WebControls.Button

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Nothing special here.
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' Normally you don't throw and catch an exception, but here we show how to
        ' incorporate an exception as the inner exception of another exception that has
        ' more properties/information, for example MyApplicationException has the
        ' WhatPage property.
        Try
            Throw New Exception("This is my exception!")
        Catch ex As Exception
            Dim myExcep As New MyApplicationException("This is a wrapper exception", ex)
            myExcep.WhatPage = "WebForm1"
            Throw myExcep  ' It's now Page_Error's responsibility
        End Try
    End Sub

    Private Sub Page_Error(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Error
        ' At this point, you can do whatever is needed with the exception. Redirect to a page (this one
        ' or an error page, log an event, etc. In this case, I simply write to the response stream.
        Dim ex As Exception
        ex = Server.GetLastError()

        If ex.GetType() Is GetType(MyApplicationException) Then
            ' Let's handle it
            Response.Write("I caught the exception. The message was :" & Server.GetLastError().Message)
            Response.Flush()
            Server.ClearError()
        Else
            ' We aren't going to clear the error, control now goes to Application_Error
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Throw New ApplicationException("Button2 from WebForm1 threw the exception")
    End Sub
End Class
