' This class implements the ISportsUtility interface, which gives it the ability to be
' used as an ISportsUtility object, and at the same time it is inheritting from Car,
' which gives it all of the properties and methods of Car.
' This allows us to effectively look like we have inherited from two different classes,
' without any confusion for the runtime or compiler that can occur in languages like C++
' which allow multiple inheritance.
Public Class SUV
    Inherits Car
    Implements ISportsUtility

    Private allWheelDrive As Boolean
    Private fourWheelDrive As Boolean
    Protected slogan As String
    Property HasAllWheelDrive() As Boolean Implements ISportsUtility.HasAllWheelDrive
        Get
            Return allWheelDrive
        End Get
        Set(ByVal Value As Boolean)
            allWheelDrive = Value
        End Set
    End Property

    Property HasFourWheelDrive() As Boolean Implements ISportsUtility.HasFourWheelDrive
        Get
            Return fourWheelDrive
        End Get
        Set(ByVal Value As Boolean)
            fourWheelDrive = Value
        End Set
    End Property

    Sub New()
        allWheelDrive = False
        fourWheelDrive = False
        slogan = String.Empty
    End Sub

    Public Function GetOffRoadSlogan() As String Implements ISportsUtility.GetOffRoadSlogan
        Return slogan
    End Function
End Class
