Public Class Vehicle
    ' Shared member variables are available directly off of the class rather than the
    ' object. 
    Private Shared PST As Decimal = 1.08
    Private Shared GST As Decimal = 1.07

    ' This is a member variable, also called a class variable
    Private wheels As Integer
    Private price As Integer
    Private colour As String
    Private name As String
    ' A property looks like a variable to anyone using the object,
    ' but it allows you to have some control over what you do.
    Property NumberOfWheels() As Integer
        Get
            Return wheels
        End Get
        Set(ByVal Value As Integer)
            wheels = Value
        End Set
    End Property

    Property ModelName() As String
        Get
            Return name
        End Get
        Set(ByVal Value As String)
            name = Value
        End Set
    End Property
    Property Value() As Integer
        Get
            Return price
        End Get
        Set(ByVal Value As Integer)
            ' This is an example of doing something when the value is set
            price = CInt(Value * GST * PST) ' converts it from decimal to an integer
        End Set
    End Property

    Sub New()
        wheels = 0
        price = 0
        colour = 0
    End Sub

    ' Overridable means that this function can be 'replaced' by a child class (derived class)
    ' with that child's own version of this function.
    Public Overridable Function Buy(ByVal amountOfMoney As Integer) As Boolean
        If amountOfMoney >= price Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
